package com.yuexiu.secp.read.controller;

import com.alibaba.fastjson.JSONObject;
import com.sie.iot.common.bean.RequestData;
import com.sie.iot.common.bean.ResponseData;
import com.sie.iot.common.model.inter.IBaseCommon;
import com.sie.iot.common.secure.annotation.CheckToken;
import com.sie.iot.common.services.CommonAbstractService;
import com.yuexiu.secp.read.dto.ArticlePreviewDto;
import com.yuexiu.secp.read.dto.CostUnitDto;
import com.yuexiu.secp.read.dto.RecommendDto;
import com.yuexiu.secp.read.model.entities.ArticlePreviewEntity;
import com.yuexiu.secp.read.model.entities.CostUnitEntity;
import com.yuexiu.secp.read.model.service.IArticlePreview;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping("/read/article/preview")
public class ArticlePreviewController extends CommonAbstractService {


    @Autowired
    private IArticlePreview iReadService;

    @Override
    public IBaseCommon<?> getBaseCommonServer() {
       return this.iReadService;;
    }

    @GetMapping(value = "/findRecommendedAndPast")
    public String findRecommendedAndPast(RecommendDto articlePreviewDto) {

      return   iReadService.findRecommendedAndPast(articlePreviewDto);
    }

    @ApiOperation(value = "保存成本单位", notes = "保存成本单位")
    @PostMapping(value = "/save")
    @CheckToken
    public ResponseData<ArticlePreviewEntity> save(@RequestBody RequestData<ArticlePreviewDto> requestData) {
        ArticlePreviewDto articlePreviewDto = requestData.getParams();

        getUserSessionBean().getUserId();

        return ResponseData.data(iReadService.saveArticlePreview(articlePreviewDto));
    }

}
